package types

type DiscoveryMessageType int

const (
	DiscoveryMessageTypeNone DiscoveryMessageType = iota
	DiscoveryMessageTypeQueueing
	DiscoveryMessageTypeQueueingFailed
	DiscoveryMessageTypeQueueingTimeout
	DiscoveryMessageTypeMode
	DiscoveryMessageTypeStart
	DiscoveryMessageTypeStop
	DiscoveryMessageTypeError
	DiscoveryMessageTypeHost
	DiscoveryMessageTypePort
	DiscoveryMessageTypeService
)

type DiscoveryRequestType int

const (
	DiscoveryRequestTypeNone DiscoveryRequestType = iota
	DiscoveryRequestTypeHost
	DiscoveryRequestTypePort
	DiscoveryRequestTypeService
)

type DiscoveryMessage func() (request DiscoveryRequest, messageType DiscoveryMessageType, datas []interface{})

func MakeDiscoveryMessage(request DiscoveryRequest, messageType DiscoveryMessageType, datas ...interface{}) DiscoveryMessage {
	return func() (DiscoveryRequest, DiscoveryMessageType, []interface{}) {
		return request, messageType, datas
	}
}

type DiscoveryRequest interface {
	RequestID() string
	RequesterID() string
	RequestType() DiscoveryRequestType
	Params() []interface{}
}
